> ## Documentation Index
> Fetch the complete documentation index at: https://docs.dittofeed.com/llms.txt
> Use this file to discover all available pages before exploring further.

# PUT /api/admin/component-configurations/

> Create or update a component configuration.



## OpenAPI

````yaml put /api/admin/component-configurations/
openapi: 3.1.0
info:
  title: Dittofeed API
  description: Dittofeed API Swagger Documentation
  version: 0.0.1
servers: []
security: []
paths:
  /api/admin/component-configurations/:
    put:
      tags:
        - ComponentConfigurations
      description: Create or update a component configuration.
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                workspaceId:
                  type: string
                name:
                  type: string
                id:
                  type: string
                definition:
                  anyOf:
                    - type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - DeliveriesTable
                        columnAllowList:
                          type: array
                          items:
                            anyOf:
                              - type: string
                                enum:
                                  - preview
                              - type: string
                                enum:
                                  - from
                              - type: string
                                enum:
                                  - to
                              - type: string
                                enum:
                                  - userId
                              - type: string
                                enum:
                                  - snippet
                              - type: string
                                enum:
                                  - channel
                              - type: string
                                enum:
                                  - status
                              - type: string
                                enum:
                                  - origin
                              - type: string
                                enum:
                                  - sentAt
                              - type: string
                                enum:
                                  - template
                              - type: string
                                enum:
                                  - updatedAt
                        userUriTemplate:
                          type: string
                        templateUriTemplate:
                          type: string
                        originUriTemplate:
                          type: string
                      required:
                        - type
                    - type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - Broadcast
                        stepsAllowList:
                          type: array
                          items:
                            anyOf:
                              - type: string
                                enum:
                                  - RECIPIENTS
                              - type: string
                                enum:
                                  - CONTENT
                              - type: string
                                enum:
                                  - CONFIGURATION
                              - type: string
                                enum:
                                  - DELIVERIES
                              - type: string
                                enum:
                                  - EVENTS
                        emailProviderOverrideAllowList:
                          type: array
                          items:
                            anyOf:
                              - type: string
                                enum:
                                  - SendGrid
                              - type: string
                                enum:
                                  - AmazonSes
                              - type: string
                                enum:
                                  - Resend
                              - type: string
                                enum:
                                  - PostMark
                              - type: string
                                enum:
                                  - Smtp
                              - type: string
                                enum:
                                  - Test
                              - type: string
                                enum:
                                  - MailChimp
                              - type: string
                                enum:
                                  - Gmail
                        hideOverrideSelect:
                          type: boolean
                        hideScheduledSelect:
                          type: boolean
                        hideRateLimit:
                          type: boolean
                        hideDrawer:
                          type: boolean
                        hideTemplateUserPropertiesPanel:
                          type: boolean
                        showErrorHandling:
                          type: boolean
                        allowedEmailContentsTypes:
                          type: array
                          items:
                            anyOf:
                              - type: string
                                enum:
                                  - Code
                              - type: string
                                enum:
                                  - LowCode
                        lowCodeEmailDefaultType:
                          anyOf:
                            - type: string
                              enum:
                                - Informative
                            - type: string
                              enum:
                                - Empty
                      required:
                        - type
                    - type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - MessageTemplate
                        allowedEmailContentsTypes:
                          type: array
                          items:
                            anyOf:
                              - type: string
                                enum:
                                  - Code
                              - type: string
                                enum:
                                  - LowCode
                        lowCodeEmailDefaultType:
                          anyOf:
                            - type: string
                              enum:
                                - Informative
                            - type: string
                              enum:
                                - Empty
                      required:
                        - type
                    - type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - AnalysisChart
                        hardcodedFilters:
                          type: object
                          properties:
                            journeyIds:
                              type: array
                              items:
                                type: string
                            broadcastIds:
                              type: array
                              items:
                                type: string
                            channels:
                              type: array
                              items:
                                type: string
                            providers:
                              type: array
                              items:
                                type: string
                            messageStates:
                              type: array
                              items:
                                type: string
                            templateIds:
                              type: array
                              items:
                                type: string
                            userIds:
                              type: array
                              items:
                                type: string
                        allowedFilters:
                          type: array
                          items:
                            anyOf:
                              - type: string
                                enum:
                                  - journeyIds
                              - type: string
                                enum:
                                  - broadcastIds
                              - type: string
                                enum:
                                  - channels
                              - type: string
                                enum:
                                  - providers
                              - type: string
                                enum:
                                  - messageStates
                              - type: string
                                enum:
                                  - templateIds
                              - type: string
                                enum:
                                  - userIds
                        allowedGroupBy:
                          type: array
                          items:
                            anyOf:
                              - type: string
                                enum:
                                  - journey
                              - type: string
                                enum:
                                  - broadcast
                              - type: string
                                enum:
                                  - messageTemplate
                              - type: string
                                enum:
                                  - provider
                        allowedChannels:
                          type: array
                          items:
                            anyOf:
                              - type: string
                                enum:
                                  - Email
                              - type: string
                                enum:
                                  - MobilePush
                              - type: string
                                enum:
                                  - Sms
                              - type: string
                                enum:
                                  - Webhook
                        columnAllowList:
                          type: array
                          items:
                            anyOf:
                              - type: string
                                enum:
                                  - preview
                              - type: string
                                enum:
                                  - from
                              - type: string
                                enum:
                                  - to
                              - type: string
                                enum:
                                  - userId
                              - type: string
                                enum:
                                  - snippet
                              - type: string
                                enum:
                                  - channel
                              - type: string
                                enum:
                                  - status
                              - type: string
                                enum:
                                  - origin
                              - type: string
                                enum:
                                  - sentAt
                              - type: string
                                enum:
                                  - template
                              - type: string
                                enum:
                                  - updatedAt
                        templateUriTemplate:
                          type: string
                        originUriTemplate:
                          type: string
                      required:
                        - type
              required:
                - workspaceId
                - name
        required: true
      responses:
        '200':
          description: Default Response
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: string
                  workspaceId:
                    type: string
                  definition:
                    anyOf:
                      - type: object
                        properties:
                          type:
                            type: string
                            enum:
                              - DeliveriesTable
                          columnAllowList:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                  enum:
                                    - preview
                                - type: string
                                  enum:
                                    - from
                                - type: string
                                  enum:
                                    - to
                                - type: string
                                  enum:
                                    - userId
                                - type: string
                                  enum:
                                    - snippet
                                - type: string
                                  enum:
                                    - channel
                                - type: string
                                  enum:
                                    - status
                                - type: string
                                  enum:
                                    - origin
                                - type: string
                                  enum:
                                    - sentAt
                                - type: string
                                  enum:
                                    - template
                                - type: string
                                  enum:
                                    - updatedAt
                          userUriTemplate:
                            type: string
                          templateUriTemplate:
                            type: string
                          originUriTemplate:
                            type: string
                        required:
                          - type
                      - type: object
                        properties:
                          type:
                            type: string
                            enum:
                              - Broadcast
                          stepsAllowList:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                  enum:
                                    - RECIPIENTS
                                - type: string
                                  enum:
                                    - CONTENT
                                - type: string
                                  enum:
                                    - CONFIGURATION
                                - type: string
                                  enum:
                                    - DELIVERIES
                                - type: string
                                  enum:
                                    - EVENTS
                          emailProviderOverrideAllowList:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                  enum:
                                    - SendGrid
                                - type: string
                                  enum:
                                    - AmazonSes
                                - type: string
                                  enum:
                                    - Resend
                                - type: string
                                  enum:
                                    - PostMark
                                - type: string
                                  enum:
                                    - Smtp
                                - type: string
                                  enum:
                                    - Test
                                - type: string
                                  enum:
                                    - MailChimp
                                - type: string
                                  enum:
                                    - Gmail
                          hideOverrideSelect:
                            type: boolean
                          hideScheduledSelect:
                            type: boolean
                          hideRateLimit:
                            type: boolean
                          hideDrawer:
                            type: boolean
                          hideTemplateUserPropertiesPanel:
                            type: boolean
                          showErrorHandling:
                            type: boolean
                          allowedEmailContentsTypes:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                  enum:
                                    - Code
                                - type: string
                                  enum:
                                    - LowCode
                          lowCodeEmailDefaultType:
                            anyOf:
                              - type: string
                                enum:
                                  - Informative
                              - type: string
                                enum:
                                  - Empty
                        required:
                          - type
                      - type: object
                        properties:
                          type:
                            type: string
                            enum:
                              - MessageTemplate
                          allowedEmailContentsTypes:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                  enum:
                                    - Code
                                - type: string
                                  enum:
                                    - LowCode
                          lowCodeEmailDefaultType:
                            anyOf:
                              - type: string
                                enum:
                                  - Informative
                              - type: string
                                enum:
                                  - Empty
                        required:
                          - type
                      - type: object
                        properties:
                          type:
                            type: string
                            enum:
                              - AnalysisChart
                          hardcodedFilters:
                            type: object
                            properties:
                              journeyIds:
                                type: array
                                items:
                                  type: string
                              broadcastIds:
                                type: array
                                items:
                                  type: string
                              channels:
                                type: array
                                items:
                                  type: string
                              providers:
                                type: array
                                items:
                                  type: string
                              messageStates:
                                type: array
                                items:
                                  type: string
                              templateIds:
                                type: array
                                items:
                                  type: string
                              userIds:
                                type: array
                                items:
                                  type: string
                          allowedFilters:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                  enum:
                                    - journeyIds
                                - type: string
                                  enum:
                                    - broadcastIds
                                - type: string
                                  enum:
                                    - channels
                                - type: string
                                  enum:
                                    - providers
                                - type: string
                                  enum:
                                    - messageStates
                                - type: string
                                  enum:
                                    - templateIds
                                - type: string
                                  enum:
                                    - userIds
                          allowedGroupBy:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                  enum:
                                    - journey
                                - type: string
                                  enum:
                                    - broadcast
                                - type: string
                                  enum:
                                    - messageTemplate
                                - type: string
                                  enum:
                                    - provider
                          allowedChannels:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                  enum:
                                    - Email
                                - type: string
                                  enum:
                                    - MobilePush
                                - type: string
                                  enum:
                                    - Sms
                                - type: string
                                  enum:
                                    - Webhook
                          columnAllowList:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                  enum:
                                    - preview
                                - type: string
                                  enum:
                                    - from
                                - type: string
                                  enum:
                                    - to
                                - type: string
                                  enum:
                                    - userId
                                - type: string
                                  enum:
                                    - snippet
                                - type: string
                                  enum:
                                    - channel
                                - type: string
                                  enum:
                                    - status
                                - type: string
                                  enum:
                                    - origin
                                - type: string
                                  enum:
                                    - sentAt
                                - type: string
                                  enum:
                                    - template
                                - type: string
                                  enum:
                                    - updatedAt
                          templateUriTemplate:
                            type: string
                          originUriTemplate:
                            type: string
                        required:
                          - type
                required:
                  - id
                  - workspaceId
                  - definition
        '400':
          description: Default Response
          content:
            application/json:
              schema:
                anyOf:
                  - type: object
                    properties:
                      type:
                        type: string
                        enum:
                          - UniqueConstraintViolation
                      message:
                        type: string
                    required:
                      - type
                      - message
                  - type: object
                    properties:
                      type:
                        type: string
                        enum:
                          - NotFound
                      message:
                        type: string
                    required:
                      - type
                      - message

````